package net.tomatentum.cutin;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import net.tomatentum.cutin.container.MethodContainer;

public class ProcessorMethodExecutor<I extends Object, C extends Object> implements MethodExecutor<C>, ProcessorContainer<I, C> {

    private Logger logger = LoggerFactory.getLogger(getClass());

    private MethodContainer<I, C> methodContainer;
    private Set<MethodProcessor<I, C>> processors;

    public ProcessorMethodExecutor(MethodContainer<I, C> methodContainer) {
        this.methodContainer = methodContainer;
        this.processors = new HashSet<>();
    }

    @Override
    public ProcessorContainer<I, C> addProcessor(MethodProcessor<I, C> processor) {
        processors.add(processor);
        return this;
    }

    @Override
    public Collection<MethodProcessor<I, C>> processor() {
        return this.processors;
    }

    @Override
    public void handle(Object context) {
        logger.debug("Handling {} context ", context);
        processors.forEach(x -> x.process(context, methodContainer));
    }
    
}
