package net.tomatentum.cutin.container;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Optional;
import java.util.Set;

import net.tomatentum.cutin.method.ReflectedMethod;

public interface MethodContainer<I extends Object, C extends Object> {

    MethodContainer<I, C> addMethod(ReflectedMethod<I, C> method);
    default MethodContainer<I, C> addMethods(ReflectedMethod<I, C>[] methods) {
        for (ReflectedMethod<I, C> reflectedMethod : methods) {
            this.addMethod(reflectedMethod);
        }
        return this;
    }
    MethodContainer<I, C> addMethods(Object containingObject, Method... methods);
    default MethodContainer<I, C> addAllMethods(Object containingObject) {
        this.addMethods(containingObject, containingObject.getClass().getDeclaredMethods());
        return this;
    }

    Set<I> identifiers();
    Collection<ReflectedMethod<I, C>> methods();
    Collection<ReflectedMethod<I, C>> findFor(I identifier);
    Optional<ReflectedMethod<I, C>> findFirstFor(I identifier);
    
}
